local
  nonfix *;
in
structure T = Term;
val * = T.Var (1);
val a = T.Con("a", []);
val b = T.Con("b", []);
val c = T.Con("c", []);
fun f(t) = T.Con("f", t);
fun g(t) = T.Con("g", t);
fun h(t) = T.Con("h", t);

structure S = IntSet;
fun sgn (k) = S.insert (k, S.empty);

structure I = PathIndex;
(*
structure I = DiscIndex;
*)

fun inserts (nil, idx, k) = idx
  | inserts (t::ts, idx, k) =
      inserts (ts, I.insert (idx, t, sgn(k)), k+1);

(* Example from lecture *)
val t1 = f [a, b];
val t2 = f [f [a, b], c];
val t3 = f [*, *];
val t4 = f [g [a], g[b]];
val t5 = f [a, f[a, b]];

val idy = inserts ([t1,t2,t3,t4,t5], I.empty, 1);
val getEqY = I.getEq idy;
val getGenY = I.getGen idy;
val getInstY = I.getInst idy;
val getUnifY = I.getUnif idy;

val y1 = getEqY (t1);
val y2 = getEqY (t2);
val y3 = getEqY (t3);
val y4 = getEqY (t4);
val y5 = getEqY (t5);

val y_a = getEqY (f [a, a]);
val y_b = getEqY (f [g [a], g[c]]);
val y_c = getEqY (f [b, *]);

val y35 = getGenY (f [a, f[a, b]]);

val y15 = getInstY (f [a, *]);
val y34 = getUnifY (f [g [*], *]);

(* Example from page 42 of "indexing" article *)
val s1 = f [g [a, *], c];
val s2 = f [g [*, b], *];
val s3 = f [g [a, b], a];
val s4 = f [g [*, c], b];
val s5 = f [*, *];

val idx = inserts ([s1,s2,s3,s4,s5], I.empty, 1);
val getEqX = I.getEq idx;
val getGenX = I.getGen idx;
val getInstX = I.getInst idx;
val getUnifX = I.getUnif idx;

val x45a = getGenX (f [g [a,c], b]);
val x1 = getInstX (f [*, c]);
val x1234 = getInstX (f [g [*, *], *]);
val x12345 = getInstX *;
val x45b = getUnifX (f [g [a,c], b]);
val x125 = getUnifX (f [*, c]);
end;
